unit MainWin;
interface               
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, OleCtrls, SHDocVw, Menus, ToolWin, ImgList, ExtDlgs,
  ExtCtrls;
type
  TMainFrm = class(TForm)
    PageCtrl: TPageControl;
    HtmlTab: TTabSheet;
    VievTab: TTabSheet;
    HtmlEd: TRichEdit;
    HtmlViev: TWebBrowser;
    MainMenu: TMainMenu;
    N1: TMenuItem;
    OpenM: TMenuItem;
    SaveM: TMenuItem;
    ExitM: TMenuItem;
    N2: TMenuItem;
    SaveAsM: TMenuItem;
    OpenDlg: TOpenDialog;
    SaveDlg: TSaveDialog;
    NewM: TMenuItem;
    ToolBar1: TToolBar;
    ToolBtn1: TToolButton;
    ToolBtn2: TToolButton;
    ToolBtn3: TToolButton;
    ToolBtn5: TToolButton;
    FontDlg: TFontDialog;
    ToolBtn4: TToolButton;
    ImgList: TImageList;
    ToolBtn6: TToolButton;
    ToolBtn7: TToolButton;
    ToolBtn8: TToolButton;
    ToolBtn11: TToolButton;
    ToolBtn12: TToolButton;
    ToolBtn13: TToolButton;
    OpenPictDlg: TOpenPictureDialog;
    ToolBtn14: TToolButton;
    ToolBtn15: TToolButton;
    ColorDlg: TColorDialog;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolBar2: TToolBar;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolBtn16: TToolButton;
    ToolBtn17: TToolButton;
    ToolBtn18: TToolButton;
    ToolBtn19: TToolButton;
    ToolBtn20: TToolButton;
    ToolBtn21: TToolButton;
    ToolBtn22: TToolButton;
    N3: TMenuItem;
    CopyM: TMenuItem;
    PasteM: TMenuItem;
    N6: TMenuItem;
    BreakM: TMenuItem;
    CutM: TMenuItem;
    FontM: TMenuItem;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    PopupMenu: TPopupMenu;
    N4: TMenuItem;
    N5: TMenuItem;
    N7: TMenuItem;
    UndoMI: TMenuItem;
    SelAllMI: TMenuItem;
    N8: TMenuItem;
    N9: TMenuItem;
    N10: TMenuItem;
    N11: TMenuItem;
    N12: TMenuItem;
    AlignM: TPopupMenu;
    N13: TMenuItem;
    N14: TMenuItem;
    N15: TMenuItem;
    N16: TMenuItem;
    N17: TMenuItem;
    N18: TMenuItem;
    N19: TMenuItem;
    ListM: TPopupMenu;
    ListMI1: TMenuItem;
    ListMI2: TMenuItem;
    ListMI3: TMenuItem;
    ListMI4: TMenuItem;
    N21: TMenuItem;
    N22: TMenuItem;
    ListMI5: TMenuItem;
    procedure ExitMClick(Sender: TObject);
    procedure OpenMClick(Sender: TObject);
    procedure PageCtrlChange(Sender: TObject);
    procedure SaveAsMClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure NewMClick(Sender: TObject);
    procedure ToolBtn1Click(Sender: TObject);
    procedure ToolBtn2Click(Sender: TObject);
    procedure ToolBtn3Click(Sender: TObject);
    procedure ToolBtn5Click(Sender: TObject);
    procedure ToolBtn4Click(Sender: TObject);
    procedure ToolBtn6Click(Sender: TObject);
    procedure ToolBtn7Click(Sender: TObject);
    procedure AlignMClick(Sender: TObject);
    procedure ToolBtn13Click(Sender: TObject);
    procedure SaveMClick(Sender: TObject);
    procedure ToolBtn11Click(Sender: TObject);
    procedure ToolBtn12Click(Sender: TObject);
    procedure ToolBtn14Click(Sender: TObject);
    procedure ToolBtn15Click(Sender: TObject);
    procedure ToolButton4Click(Sender: TObject);
    procedure ToolButton6Click(Sender: TObject);
    procedure ToolBtn16Click(Sender: TObject);
    procedure ToolBtn17Click(Sender: TObject);
    procedure ToolBtn19Click(Sender: TObject);
    procedure ToolBtn18Click(Sender: TObject);
    procedure ToolBtn21Click(Sender: TObject);
    procedure ToolBtn22Click(Sender: TObject);
    procedure CenterMClick(Sender: TObject);
    procedure CopyMClick(Sender: TObject);
    procedure CutMClick(Sender: TObject);
    procedure PasteMClick(Sender: TObject);
    procedure BreakMClick(Sender: TObject);
    procedure FontMClick(Sender: TObject);
    procedure ToolButton8Click(Sender: TObject);
    procedure UndoMIClick(Sender: TObject);
    procedure SelAllMIClick(Sender: TObject);
    procedure ToolBtn8Click(Sender: TObject);
    procedure ListMClick(Sender: TObject);
  private
    procedure AddNewTag(S1,S2:string);
  public
  end;
function HexString(i:integer):string;
var
  MainFrm: TMainFrm;
  FName:string;
implementation
uses SizeWin,PictWin,RxGIF,Jpeg, TablWin, NewWin, AddColWin,
  AddRowWin, LineWin, HeadWin;
{$R *.DFM}
{$R Panel.res}
function HexString(i:integer):string;
var
  TempS:string;
  Ch:char;
begin
  TempS:=inttohex(i,6);
  Ch:=TempS[1]; TempS[1]:=TempS[5]; TempS[5]:=Ch;
  Ch:=TempS[2]; TempS[2]:=TempS[6]; TempS[6]:=Ch;
  Result:='#'+TempS;
end;
function ReturnPatch(S: string): string;
var
  TempS:string;
function Perebor(S:string):string;
var
  i:integer;
begin
  for i:=1 to Length(S) do
    if S[i]='\' then S[i]:='/';
  Result:=S;
end;
begin
  TempS:=ExtractFilePath(FName);
  Result:=Perebor(ExtractRelativePath(TempS,S)); // 
end;
procedure TMainFrm.ExitMClick(Sender: TObject);
begin
  Close;
end;
procedure TMainFrm.OpenMClick(Sender: TObject);
begin
  if OpenDlg.Execute then
  begin
    FName:=OpenDlg.FileName;
    HtmlEd.Lines.LoadFromFile(FName);
    Caption:='HTML  ('+FName+')';
  end;
end;
procedure TMainFrm.PageCtrlChange(Sender: TObject);
begin
  if PageCtrl.ActivePage=VievTab then
  if FName='' then SaveAsMClick(Sender)
  else HtmlEd.Lines.SaveToFile(FName);
  if FName<>'' then HtmlViev.Navigate(FName)
  else PageCtrl.ActivePage:=HtmlTab;
end;
procedure TMainFrm.SaveAsMClick(Sender: TObject);
begin
  if SaveDlg.Execute then
  begin
//HtmlEd.PlainText:=true; -   ,   
    FName:=SaveDlg.FileName;
    if pos('.HTM',UpperCase(FName))=0 then FName:=FName+'.htm';
    HtmlEd.Lines.SaveToFile(FName);
    Caption:='HTML  ('+FName+')';
  end;
end;
procedure TMainFrm.FormShow(Sender: TObject);
var
  r:TRect;
begin
  SystemParametersInfo(SPI_GETWORKAREA,0,@r,0);
  BoundsRect:=r; //    . 
  ImgList.ResourceLoad(rtBitmap,'PANEL',clSilver);
  FName:='';
end;
procedure TMainFrm.NewMClick(Sender: TObject);
var
  S:string;
begin
  with NewFrm do
  begin
    if ShowModal<>mrOk then exit;
    MainFrm.Caption:='HTML  ( )';
    FName:='';
    SaveDlg.FileName:='';
    SaveAsMClick(Sender);
    HtmlEd.Clear;
    HtmlEd.Lines.Add('<HTML>');
    HtmlEd.Lines.Add('<HEAD>');
    HtmlEd.Lines.Add('<TITLE>'+CaptEd.Text+'</TITLE>');
    if BaseEd.Text<>'' then HtmlEd.Lines.Add('<BASE HREF="'+BaseEd.Text+'">');
    HtmlEd.Lines.Add('</HEAD>');
    S:='<BODY';
    if PictEd.Text<>'' then S:=S+' BACKGROUND="'+ReturnPatch(PictEd.Text)+'"';
    if ColorEd.Text<>'' then S:=S+' BGCOLOR='+ColorEd.Text;
    if TextEd.Text<>'' then S:=S+' TEXT='+TextEd.Text;
    if GipDefEd.Text<>'' then S:=S+' LINK='+GipDefEd.Text;
    if GipProEd.Text<>'' then S:=S+' VLINK='+GipProEd.Text;
    if GipPressEd.Text<>'' then S:=S+' ALINK='+GipPressEd.Text;
    S:=S+'>'#13#10;
    HtmlEd.Lines.Add(S);
    HtmlEd.Lines.Add('</BODY>');
    HtmlEd.Lines.Add('</HTML>');
  end;
end;
procedure TMainFrm.ToolBtn1Click(Sender: TObject);
begin
  AddNewTag('<I>','</I>');
end;
procedure TMainFrm.ToolBtn2Click(Sender: TObject);
begin
  AddNewTag('<B>','</B>');
end;
procedure TMainFrm.ToolBtn3Click(Sender: TObject);
begin
  AddNewTag('<U>','</U>');
end;
procedure TMainFrm.ToolBtn4Click(Sender: TObject);
begin
  AddNewTag('<S>','</S>');
end;
procedure TMainFrm.AddNewTag(S1,S2: string);
var
  i:integer;
  S:string;
begin
  i:=HtmlEd.SelStart;
  S:=S1+HtmlEd.SelText+S2;
  HtmlEd.SelText:=S;
  HtmlEd.SelStart:=i;
  HtmlEd.SelLength:=Length(S);
  HtmlEd.SelAttributes:=HtmlEd.DefAttributes;
end;
procedure TMainFrm.ToolBtn5Click(Sender: TObject);
var
  S1,S2:string;
begin
  if FontDlg.Execute then
  begin
    if SizeFrm.ShowModal<>mrOk then exit;
    S1:='<FONT COLOR='+HexString(FontDlg.Font.Color)+' ';
    S1:=S1+'FACE="'+FontDlg.Font.Name+'" ';
    S1:=S1+'SIZE='+SizeFrm.SizeEd.Text+'>';
    S2:='</FONT>';  //fsBold, fsItalic, fsUnderline, fsStrikeOut
    if fsBold in FontDlg.Font.Style then
    begin
      S1:='<B>'+S1; S2:=S2+'</B>';
    end;
    if fsItalic in FontDlg.Font.Style then
    begin
      S1:='<I>'+S1; S2:=S2+'</I>';
    end;
    if fsUnderline in FontDlg.Font.Style then
    begin
      S1:='<U>'+S1; S2:=S2+'</U>';
    end;
    if fsStrikeOut in FontDlg.Font.Style then
    begin
      S1:='<S>'+S1; S2:=S2+'</S>';
    end;
    AddNewTag(S1,S2);
  end;
end;
procedure TMainFrm.ToolBtn6Click(Sender: TObject);
begin
  AddNewTag('<SUP>','</SUP>');
end;
procedure TMainFrm.ToolBtn7Click(Sender: TObject);
begin
  AddNewTag('<SUB>','</SUB>');
end;
procedure TMainFrm.AlignMClick(Sender: TObject);
var
  S:string;
begin
  if AlignM.Tag=1 then S:='<DIV ALIGN=' else S:='<P ALIGN=';
  if Sender=N13 then S:=S+'LEFT'
  else if Sender=N14 then S:=S+'CENTER'
  else if Sender=N15 then S:=S+'RIGHT';
  if AlignM.Tag=1 then AddNewTag(S+'>','</DIV>')
  else AddNewTag(S+'>'#13#10,'');
end;
procedure TMainFrm.ToolBtn13Click(Sender: TObject);
var
  S:string;
begin
  if FName='' then SaveAsMClick(Sender);
  if FName='' then exit;
  if OpenPictDlg.Execute then
  begin
    PictFrm.Img.Picture.LoadFromFile(OpenPictDlg.FileName);
    if PictFrm.ShowModal<>mrOk then exit;
    S:='<IMG SRC="'+ReturnPatch(OpenPictDlg.FileName)+'"';
    S:=S+' WIDTH='+PictFrm.WEd.Text+' HEIGHT='+PictFrm.HEd.Text;
    S:=S+' ALT="'+PictFrm.TextEd.Text+'"';
    S:=S+' BORDER='+PictFrm.BorderEd.Text+'>';
    AddNewTag(S,'');
  end;
end;
procedure TMainFrm.SaveMClick(Sender: TObject);
begin
  if FName='' then SaveAsMClick(Sender)
  else HtmlEd.Lines.SaveToFile(FName);
end;
procedure TMainFrm.ToolBtn11Click(Sender: TObject);
var
  P:TPoint;
begin
  with Sender as TToolButton do
  begin
    P:=ToolBar1.ClientToScreen(Point(Left,Top));
    ListM.Popup(P.x,P.y);
  end;
end;
procedure TMainFrm.ToolBtn12Click(Sender: TObject);
begin
  AddNewTag('<LI>','');
end;
procedure TMainFrm.ToolBtn14Click(Sender: TObject);
begin
  if FName='' then SaveAsMClick(Sender);
  if FName='' then exit;
  if OpenDlg.Execute then
    AddNewTag('<A HREF="'+ReturnPatch(OpenDlg.FileName)+'">','</A>');
end;
procedure TMainFrm.ToolBtn15Click(Sender: TObject);
var
  S:string;
begin
  with TablFrm do
  begin
    if ShowModal<>mrOk then exit;
    S:='<TABLE';
    if BorderEd.Text<>'' then S:=S+' BORDER='+BorderEd.Text;
    if WEd.Text<>'' then S:=S+' WIDTH='+WEd.Text;
    if OtstupEd.Text<>'' then S:=S+' CELLPADDING='+OtstupEd.Text; //  
    if WLineEd.Text<>'' then S:=S+' CELLSPACING='+WLineEd.Text;   // 
    if ColorEd.Text<>'' then S:=S+' BGCOLOR='+ColorEd.Text;
    if PictEd.Text<>'' then S:=S+' BACKGROUND="'+ReturnPatch(PictEd.Text)+'"';
    S:=S+'>'#13#10;
    if CaptEd.Text<>'' then
    begin
      S:=S+'<CAPTION ALIGN=';
      if CaptCb.Checked then S:=S+'BOTTOM>' else S:=S+'TOP>';
      S:=S+CaptEd.Text+'</CAPTION>'#13#10;
    end;
    AddNewTag(S,#13#10'</TABLE>');
  end;
end;
procedure TMainFrm.ToolButton4Click(Sender: TObject);
begin
  HtmlViev.GoBack;
end;
procedure TMainFrm.ToolButton6Click(Sender: TObject);
begin
  HtmlViev.GoForward;
end;
procedure TMainFrm.ToolBtn16Click(Sender: TObject);
var
  S:string;
begin
  with RowFrm do
  begin
    if ShowModal<>mrOk then exit;
    S:='<TR';
    if HEd.Text<>'' then S:=S+' HEIGHT='+HEd.Text;
    if ColorEd.Text<>'' then S:=S+' BGCOLOR='+ColorEd.Text;
    S:=S+'>'#13#10;
    AddNewTag(S,#13#10'</TR>');
  end;
end;
procedure TMainFrm.ToolBtn17Click(Sender: TObject);
var
  S,TempS:string;
begin
  with ColFrm do
  begin
    if ShowModal<>mrOk then exit;
    TempS:='';
    if SizeWEd.Text<>'1' then TempS:=' COLSPAN='+SizeWEd.Text;
    if SizeHEd.Text<>'1' then TempS:=TempS+' ROWSPAN='+SizeHEd.Text;
    if HeaderCb.Checked then
    begin
      S:='<TH'+TempS+'>'#13#10;
      if TextMm.Lines.Text<>'' then S:=S+TextMm.Lines.Text;
      AddNewTag(S,#13#10'</TH>');
      exit;
    end;
    S:='<TD';
    if WEd.Text<>'' then S:=S+' WIDTH='+WEd.Text;
    if ColorEd.Text<>'' then S:=S+' BGCOLOR='+ColorEd.Text;
    S:=S+' ALIGN=';
    case RG1.ItemIndex of
      0:S:=S+'LEFT';
      1:S:=S+'CENTER';
      2:S:=S+'RIGHT';
    end;
    S:=S+' VALIGN=';
    case RG2.ItemIndex of
      0:S:=S+'TOP';
      1:S:=S+'MIDDLE';
      2:S:=S+'BOTTOM';
    end;
    S:=S+TempS+'>'#13#10;
    if TextMm.Lines.Text<>'' then S:=S+TextMm.Lines.Text;
    AddNewTag(S,#13#10'</TD>');
  end;
end;
procedure TMainFrm.ToolBtn19Click(Sender: TObject);
begin
  AddNewTag('<BR>'#13#10,'');
end;
procedure TMainFrm.ToolBtn18Click(Sender: TObject);
var
  S:string;
begin
  with LineFrm do
  begin
    if ShowModal<>mrOk then exit;
    S:='<HR';
    if WEd.Text<>'' then S:=S+' WIDTH='+WEd.Text;
    if HEd.Text<>'' then S:=S+' SIZE='+HEd.Text;
    if ColorEd.Text<>'' then S:=S+' COLOR='+ColorEd.Text;
    S:=S+' ALIGN=';
    case RG.ItemIndex of
      0:S:=S+'LEFT';
      1:S:=S+'CENTER';
      2:S:=S+'RIGHT';
    end;
    S:=S+'>'#13#10;
    AddNewTag(S,'');
  end;
end;
procedure TMainFrm.ToolBtn21Click(Sender: TObject);
begin
  AddNewTag('<BIG>','</BIG>');
end;
procedure TMainFrm.ToolBtn22Click(Sender: TObject);
begin
  AddNewTag('<SMALL>','</SMALL>');
end;
procedure TMainFrm.CenterMClick(Sender: TObject);
begin
  AddNewTag('<CENTER>','</CENTER>');
end;
procedure TMainFrm.CopyMClick(Sender: TObject);
begin
  HtmlEd.CopyToClipboard;
end;
procedure TMainFrm.CutMClick(Sender: TObject);
begin
  HtmlEd.CutToClipboard;
end;
procedure TMainFrm.PasteMClick(Sender: TObject);
begin
  HtmlEd.PasteFromClipboard;
end;
procedure TMainFrm.BreakMClick(Sender: TObject);
begin
  HtmlEd.WordWrap:=not HtmlEd.WordWrap;
  BreakM.Checked:=HtmlEd.WordWrap;    
end;
procedure TMainFrm.FontMClick(Sender: TObject);
begin
  FontDlg.Font:=HtmlEd.Font;
  if FontDlg.Execute then HtmlEd.Font:=FontDlg.Font;
end;
procedure TMainFrm.ToolButton8Click(Sender: TObject);
var
  S:string;
begin
  with HeadFrm do
  begin
    if ShowModal<>mrOk then exit;
    S:='<H'+SizeEd.Text;
    S:=S+' ALIGN=';
    case RG.ItemIndex of
      0:S:=S+'LEFT';
      1:S:=S+'CENTER';
      2:S:=S+'RIGHT';
    end;
    S:=S+'>'#13#10;
    AddNewTag(S,'</H'+SizeEd.Text+'>');
  end;
end;
procedure TMainFrm.UndoMIClick(Sender: TObject);
begin
  HtmlEd.Undo;
end;
procedure TMainFrm.SelAllMIClick(Sender: TObject);
begin
  HtmlEd.SelectAll;
end;
procedure TMainFrm.ToolBtn8Click(Sender: TObject);
var
  P:TPoint;
begin
  with Sender as TToolButton do
  begin
    P:=ToolBar1.ClientToScreen(Point(Left,Top));
    AlignM.Tag:=Tag;
    N16.Visible:=Tag=1;
    N17.Visible:=Tag=1;
    AlignM.Popup(P.x,P.y);
  end;
end;
procedure TMainFrm.ListMClick(Sender: TObject);
var
  S1,S2:string;
begin
  S1:='<OL TYPE=';
  case (Sender as TMenuItem).Tag of
    0:S1:=S1+'1>';
    1:S1:=S1+'A>';
    2:S1:=S1+'a>';
    3:S1:=S1+'I>';
    4:S1:='<UL>';
  end;
  if S1='<UL>' then S2:='</UL>' else S2:='</OL>';
  S1:=S1+'<LH>';
  S1:=S1+#13#10;
  S2:=#13#10+S2;
  AddNewTag(S1,S2);
end;
end.
